#ifndef _FILTER_H_
#define _FILTER_H_

#include "useful.h"

bool is_connected(const adjacency_matrix_t &matrix, int n);
static const int MultiplyDeBruijnBitPosition[32] =
{
  0, 1, 28, 2, 29, 14, 24, 3, 30, 22, 20, 15, 25, 17, 4, 8,
  31, 27, 13, 23, 21, 19, 16, 7, 26, 12, 18, 6, 11, 5, 10, 9
};
inline int ls1b(uint32_t x) {
  return MultiplyDeBruijnBitPosition[((uint32_t)((x & -x) * 0x077CB531U)) >> 27];
}

#endif
